<?xml version="1.0" encoding="UTF-8"?>
<!--Multiple camera strategy config table-->
<MultiCameraConfigTable>
    <rule name = "ZOOM[0.99 - 1.01) Entering macro pre dual stream">
        <condition name = "ZOOM_RATIO" min = "0.99" max = "1.01"/>
        <condition name = "MACRO_MODE" value = "1"/>
        <condition name = "APK_MACRO_WU" value = "1"/>
        <outState>
            <camera name = "wide" prev = "true"/>
            <camera name = "ultra_wide"/>
        </outState>
    </rule>

    <rule name = "ZOOM[0.99 - 1.01) Exiting macro pre dual stream">
        <condition name = "ZOOM_RATIO" min = "0.99" max = "1.01"/>
        <condition name = "MACRO_MODE" value = "2"/>
        <condition name = "APK_MACRO_WU" value = "1"/>
        <outState>
            <camera name = "ultra_wide" prev = "true"/>
            <camera name = "wide"/>
        </outState>
    </rule>

    <rule name = "ZOOM[0.99 - 1.01) In macro dual stream for vcm">
        <condition name = "ZOOM_RATIO" min = "0.99" max = "1.01"/>
        <condition name = "MACRO_MODE" value = "3"/>
        <condition name = "APK_MACRO_WU" value = "1"/>
        <outState>
            <camera name = "ultra_wide" prev = "true"/>
            <camera name = "wide"/>
        </outState>
    </rule>

    <rule name = "ZOOM[0.99 - 1.01) macro stop dual stream">
        <condition name = "ZOOM_RATIO" min = "0.99" max = "1.01"/>
        <condition name = "MACRO_MODE" value = "4"/>
        <condition name = "APK_MACRO_WU" value = "1"/>
        <outState>
            <camera name = "ultra_wide" prev = "true"/>
            <camera name = "wide" />
        </outState>
    </rule>

    <rule name = "parent rule: ZOOM[0.4-1.0)">
        <condition name = "ZOOM_RATIO" min = "0.4" max = "1.0"/>
        <outState>
            <camera name = "ultra_wide" prev = "true"/>
        </outState>

        <rule name = "child rule: ZOOM[0.6-1.0) SNAPSHOTMODE = 40.0">
            <condition name = "ZOOM_RATIO" min = "0.6" max = "1.0"/>
            <condition name = "SNAPSHOT_MODE"  value= "40"/>
            <outState>
                <camera name = "ultra_wide" prev = "true"/>
                <camera name = "wide"/>
            </outState>
        </rule>

        <rule name = "child rule: ZOOM[0.8-1.0)">
            <condition name = "ZOOM_RATIO" min = "0.8" max = "1.0"/>
            <outState>
                <camera name = "ultra_wide" prev = "true"/>
                <camera name = "wide"/>
            </outState>
        </rule>
    </rule>

    <rule name = "parent rule: ZOOM[1.0-3.5)">
        <condition name = "ZOOM_RATIO" min = "1.0" max = "3.5"/>
        <outState>
            <camera name = "wide" prev = "true"/>
        </outState>

        <rule name = "open dual stream for superMacro">
            <condition name = "ZOOM_RATIO" min = "1.0" max = "1.09"/>
            <condition name = "ZOOM_STATUS" value = "3"/>
            <outState>
                <camera name = "wide" prev = "true"/>
                <camera name = "ultra_wide"/>
            </outState>
        </rule>

        <rule name = "already in superMacro">
            <condition name = "ZOOM_RATIO" min = "1.0" max = "1.09"/>
            <condition name = "ZOOM_STATUS" value = "4"/>
            <condition name = "APK_MACRO_WU" value = "1"/>
            <outState>
                <camera name = "ultra_wide" prev = "true"/>
            </outState>
        </rule>

        <rule name = "exiting in superMacro">
            <condition name = "ZOOM_RATIO" min = "1.0" max = "1.09"/>
            <condition name = "ZOOM_STATUS" value = "2"/>
            <condition name = "APK_MACRO_WU" value = "1"/>
            <outState>
                <camera name = "ultra_wide" prev = "true"/>
                <camera name = "wide"/>
            </outState>
        </rule>

        <rule name = "child rule: ZOOM[2.0,3.5), SNAPSHOTMODE = 39">
            <condition name = "ZOOM_RATIO" min = "2.0" max = "3.5"/>
            <condition name = "SNAPSHOT_MODE" value= "39"/>
            <outState>
                <camera name = "wide" prev = "true"/>
                <camera name = "tele"/>
            </outState>
        </rule>

        <rule name = "child rule: ZOOM[2.6,3.5)">
            <condition name = "ZOOM_RATIO" min = "2.6" max = "3.5"/>
            <outState>
                <camera name = "wide" prev = "true"/>
                <camera name = "tele"/>
            </outState>
        </rule>
    </rule>

    <rule name = "parent rule: ZOOM[3.5-10.0x) multicamera display prev wide">
        <!-- default switch to wide -->
        <condition name = "ZOOM_RATIO" min = "3.5" max = "10.0"/>
        <condition name = "APK_MACRO_WT" value = "2"/>
        <outState>
            <camera name = "wide" prev = "true"/>
            <camera name = "tele"/>
        </outState>
    </rule>

    <rule name = "parent rule: ZOOM[3.5-10.0x) multicamera display prev tele">
        <!-- default switch to wide -->
        <condition name = "ZOOM_RATIO" min = "3.5" max = "10.0"/>
        <condition name = "APK_MACRO_WT" value = "3"/>
        <outState>
            <camera name = "tele" prev = "true"/>
            <camera name = "wide"/>
        </outState>
    </rule>

    <rule name = "parent rule: ZOOM[3.5-7.0x)">
        <!-- default switch to wide -->
        <condition name = "ZOOM_RATIO" min = "3.5" max = "7.0"/>
        <outState>
            <camera name = "tele" prev = "true"/>
        </outState>

        <rule name = "ZOOM[3.5-7.0x) lower brightness">
            <condition name = "ZOOM_RATIO" min = "3.5" max = "7.0"/>
            <condition name = "LUX_INDEX" min = "390" max = "9999" hysteresis_min = "70.0"/>
            <outState>
                <camera name = "wide" prev = "true"/>
            </outState>
        </rule>


        <rule  name = "ZOOM[3.5-7.0x) lower objDis ->dualstreams">
            <condition name = "ZOOM_RATIO" min = "3.5" max = "7.0"/>
            <condition name = "DISTANCE_CHANGE" value= "1"/>
            <condition name = "OBJECT_DISTANCE" min = "0.0" max = "1100.0" hysteresis_max = "200.0"/>
            <condition name = "APK_MACRO_WT" value = "1"/>
            <outState>
                <camera name = "wide" prev = "true" display = "true"/>
                <camera name = "tele"/>
            </outState>
        </rule>

        <rule  name = "ZOOM[3.5-7.0x) lower objDis ->tele">
            <condition name = "ZOOM_RATIO" min = "3.5" max = "7.0"/>
            <condition name = "DISTANCE_CHANGE" value= "1"/>
            <condition name = "OBJECT_DISTANCE" min = "1300.0" max = "9999.0" hysteresis_min = "200.0"/>
            <outState>
                <camera name = "tele" prev = "true" />
                <camera name = "wide"/>
            </outState>
        </rule>

        <rule  name = "ZOOM[3.5-7.0x) lower objDis">
            <condition name = "ZOOM_RATIO" min = "3.5" max = "7.0"/>
            <condition name = "OBJECT_DISTANCE" min = "0.0" max = "1100.0" hysteresis_max = "200.0"/>
            <condition name = "APK_MACRO_WT" value = "1"/>
            <outState>
                <camera name = "wide" prev = "true" display = "true"/>
            </outState>
        </rule>
    </rule>

    <rule name = "parent rule: ZOOM[7.0-10.0x)">
        <!-- default switch to wide -->
        <condition name = "ZOOM_RATIO" min = "7.0" max = "10.0"/>
        <outState>
            <camera name = "tele" prev = "true"/>
        </outState>

        <rule name = "child rule: ZOOM[7.0-10.0x)">
            <condition name = "ZOOM_RATIO" min = "7.0" max = "10.0"/>
            <condition name = "LUX_INDEX" min = "390" max = "9999" hysteresis_min = "70.0"/>
            <outState>
                <camera name = "wide" prev = "true"/>
            </outState>
        </rule>

        <rule  name = "child rule: ZOOM[7.0-10.0x) objDis lower than 1300 ->dualstreams">
            <condition name = "ZOOM_RATIO" min = "7.0" max = "10.0"/>
            <condition name = "DISTANCE_CHANGE" value= "1"/>
            <condition name = "OBJECT_DISTANCE" min = "0.0" max = "1100.0" hysteresis_max = "200.0"/>
            <condition name = "APK_MACRO_WT" value = "1"/>
            <outState>
                <camera name = "wide" prev = "true" display = "true"/>
                <camera name = "tele"/>
            </outState>
        </rule>

        <rule  name = "child rule: ZOOM[7.0-10.0x) objDis lower than 1300 ->tele">
            <condition name = "ZOOM_RATIO" min = "7.0" max = "10.0"/>
            <condition name = "DISTANCE_CHANGE" value= "1"/>
            <condition name = "OBJECT_DISTANCE" min = "1300.0" max = "9999.0" hysteresis_min = "200.0"/>
            <outState>
                <camera name = "tele" prev = "true" />
                <camera name = "wide"/>
            </outState>
        </rule>

        <rule  name = "child rule: ZOOM[7.0-10.0x) objDis lower than 1300">
            <condition name = "ZOOM_RATIO" min = "7.0" max = "10.0"/>
            <condition name = "OBJECT_DISTANCE" min = "0.0" max = "1100.0" hysteresis_max = "200.0"/>
            <condition name = "APK_MACRO_WT" value = "1"/>
            <outState>
                <camera name = "wide" prev = "true" display = "true"/>
            </outState>
        </rule>

        <rule name = "ZOOM[7.0-10.0x) teleQuadraAiraw">
            <condition name = "ZOOM_RATIO" min = "7.0" max = "10.0"/>
            <condition name = "FEATURE_UUID" value = "teleQuadraAiraw"/>
            <outState>
                <camera name = "tele" prev = "true" stage = "remosaic"/>
            </outState>
        </rule>
    </rule>

    <rule name = "parent rule: ZOOM[10.0-100.0x]">
        <!-- default switch to wide -->
        <condition name = "ZOOM_RATIO" min = "10.0" max = "100.1"/>
        <outState>
            <camera name = "tele" prev = "true"/>
        </outState>

        <rule name = "ZOOM[10.0-100.0x] teleQuadraAiraw">
            <condition name = "ZOOM_RATIO" min = "10.0" max = "100.1"/>
            <condition name = "FEATURE_UUID" value = "teleQuadraAiraw"/>
            <outState>
                <camera name = "tele" prev = "true" stage = "remosaic"/>
            </outState>
        </rule>
    </rule>
</MultiCameraConfigTable>
